# Release Checklist

1. Check tests, linters.
2. Check issues and pull requests, update milestones and labels.
3. Create draft release on GitHub with autogenerated release notes.
4. Tweak generated release notes:
   * Ensure that "This section should be empty" section does not exist.
   * Add "All closed issues and pull requests" and "All commits".
5. Update CHANGELOG.md with the same release notes.
6. Make a signed tag `vX.Y.Z` with the relevant section of the changelog (without leading `##`).
7. Push it!
8. Make [release](https://github.com/FerretDB/FerretDB/releases).
9. Refresh
   * `env GOPROXY=https://proxy.golang.org go get -v github.com/FerretDB/FerretDB@<tag>`
   * https://pkg.go.dev/github.com/FerretDB/FerretDB
10. `make docker`, add tag, push image.
